%if %{defined fedora}
%bcond_without manual
%else
%bcond_with manual
%endif

Name:           urweb
Version:        20200209
Release:        1%{?dist}
Summary:        A statically-typed programming language for Web applications

License:        BSD
URL:            http://www.impredicative.com/ur/
Source0:        https://github.com/urweb/urweb/releases/download/%{version}/%{name}-%{version}.tar.gz

BuildRequires:  mlton
%if %{defined fedora}
BuildRequires:  libpq-devel
%else
BuildRequires:  postgresql-devel
%endif
BuildRequires:  mariadb-devel
BuildRequires:  sqlite-devel
BuildRequires:  libicu-devel
# for macros.emacs
BuildRequires:  emacs-common
%if %{with manual}
BuildRequires:  texlive-ae
BuildRequires:  texlive-ec
BuildRequires:  texlive-latex
BuildRequires:  texlive-lkproof
BuildRequires:  texlive-metafont
BuildRequires:  texlive-mfware
BuildRequires:  texlive-preprint
%endif
%if %{defined fedora}
Recommends:     emacs(bin)
%else
Requires:       emacs(bin)
%endif

%description
Ur/Web is a Free and Open source functional programming language specific for
web development, created by Adam Chlipala at MIT that from a single program
produces server code, browser client code and SQL code specific for
the chosen database backend.


%package static
Summary:        Static libs for urweb

%description static
Static libraries for Ur/Web


%prep
%autosetup


%build
%configure
%make_build

%if %{with manual}
make -C doc manual.pdf
%endif


%install
%make_install

rm %{buildroot}%{_libdir}/liburweb*.la

mkdir -p %{buildroot}%{_emacs_sitestartdir}
mv %{buildroot}%{_emacs_sitelispdir}/urweb-mode/urweb-mode-startup.el %{buildroot}%{_emacs_sitestartdir}/


%check
make test


%files
%license LICENSE
%doc doc/*.ur
%if %{with manual}
%doc doc/manual.pdf
%endif
%{_bindir}/urweb
%{_includedir}/urweb
%{_prefix}/lib/urweb
%{_libdir}/liburweb*
%exclude %{_libdir}/liburweb*.a
%{_emacs_sitestartdir}/urweb-mode-startup.el
%{_emacs_sitelispdir}/urweb-mode


%files static
%{_libdir}/liburweb*.a


%changelog
* Sat Apr 18 2020 Jens Petersen <petersen@redhat.com>
- inital packaging
